<template>
  <transition
    :name="name"
    :mode="mode"
    :enter-active-class="enterActiveClass"
    @beforeLeave="beforeLeave"
    @enter="enter"
    @afterEnter="afterEnter">
    <slot/>
  </transition>
</template>

<script>
const DEFAULT_TRANSITION = 'fade'
const DEFAULT_TRANSITION_MODE = 'out-in'

export default {
  name: 'TransitionPage',

  data () {
    return {
      name: DEFAULT_TRANSITION,
      mode: DEFAULT_TRANSITION_MODE,
      prevHeight: 0,
      enterActiveClass: ''
    }
  },

  watch: {
    '$route' (to, from) {
      let name = to.meta.transition || DEFAULT_TRANSITION
      const parentChild = from.path.indexOf(to.path) === 0 || to.path.indexOf(from.path) === 0

      if (name === 'slide' || parentChild) {
        const toDepth = to.path.replace(/\/$/, '').split('/').length
        const fromDepth = from.path.replace(/\/$/, '').split('/').length
        name = toDepth < fromDepth ? 'slide-right' : 'slide-left'
      }

      this.mode = DEFAULT_TRANSITION_MODE
      this.enterActiveClass = `${name}-enter-active`

      if (to.meta.transition === 'zoom') {
        this.mode = 'in-out'
        this.enterActiveClass = 'zoom-enter-active'
        document.body.style.overflow = 'hidden'
      }

      if (from.meta.transition === 'zoom') {
        this.mode = null
        this.enterActiveClass = null
        document.body.style.overflow = null
      }

      this.name = name
    }
  },

  methods: {
    beforeLeave (element) {
      this.prevHeight = getComputedStyle(element).height
    },

    enter (element) {
      const { height } = getComputedStyle(element)

      element.style.height = this.prevHeight

      setTimeout(() => {
        element.style.height = height
      })
    },

    afterEnter (element) {
      element.style.height = 'auto'
    }
  }
}
</script>
